'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ModelType = exports.Model = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _uri = require('rheactor-value-objects/uri');

var _uri2 = _interopRequireDefault(_uri);

var _tcomb = require('tcomb');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Model = exports.Model = function () {
  function Model($context) {
    _classCallCheck(this, Model);

    _uri2.default.Type($context);
    this.$context = $context;
    this.$links = [];
  }

  /**
   * @returns {{$context: string, $links: Array<{href: string, $context: string}>}}
   */


  _createClass(Model, [{
    key: 'toJSON',
    value: function toJSON() {
      return {
        $context: this.$context.toString(),
        $links: this.$links
      };
    }
  }]);

  return Model;
}();

var ModelType = exports.ModelType = (0, _tcomb.irreducible)('ModelType', function (x) {
  return x instanceof Model;
});